"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug")("http_request_helper");
var _ = require("lodash");
var rp = require("request-promise");
// import logger from "./logger";
var http_service_renderer_1 = require("./http_service_renderer");
var request_helper_1 = require("./request_helper");
var HttpRequestHelper = /** @class */ (function (_super) {
    __extends(HttpRequestHelper, _super);
    function HttpRequestHelper(serviceData) {
        var _this = _super.call(this) || this;
        _this.serviceData = _.cloneDeep(serviceData);
        return _this;
    }
    HttpRequestHelper.prototype.run = function (args) {
        this.renderer = new http_service_renderer_1.default(this.serviceData, args);
        var rendered = this.renderer.render();
        debug("# rendered start");
        debug(rendered);
        debug("# rendered end");
        var options = {
            json: rendered.json,
            qs: rendered.query,
            uri: rendered.baseUrl + ":" + rendered.port + rendered.path
        };
        debug(options);
        return new Promise(function (resolve, reject) {
            rp(options)
                .then(function (result) {
                resolve(result);
            })
                .catch(function (err) {
                // logger.error(err);
                // logger.error(err.body);
                throw err;
            });
        });
    };
    return HttpRequestHelper;
}(request_helper_1.RequestHelper));
exports.default = HttpRequestHelper;
//# sourceMappingURL=http_request_helper.js.map