"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var Mustache = require("mustache");
var service_renderer_1 = require("./service_renderer");
var HttpServiceRenderer = /** @class */ (function (_super) {
    __extends(HttpServiceRenderer, _super);
    function HttpServiceRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HttpServiceRenderer.prototype.render = function () {
        this.mergeArgsAndEnv();
        return {
            json: _.get(this.serviceData, "requestOptions.json", false),
            query: this.renderQuery(),
            baseUrl: this.renderBaseUrl(),
            port: this.renderPort(),
            path: this.renderPath()
        };
    };
    HttpServiceRenderer.prototype.renderBaseUrl = function () {
        var rawHost = _.get(this.serviceData, "requestOptions.host", "");
        return Mustache.render(rawHost, this.templateArgs);
    };
    HttpServiceRenderer.prototype.renderPort = function () {
        var rawPort = _.get(this.serviceData, "requestOptions.port", "");
        return Mustache.render(rawPort, this.templateArgs);
    };
    HttpServiceRenderer.prototype.renderPath = function () {
        var path = _.get(this.serviceData, "requestOptions.path", "");
        return Mustache.render(path, this.templateArgs);
    };
    HttpServiceRenderer.prototype.renderQuery = function () {
        var _this = this;
        var queryWithArgs = _.get(this.serviceData, "requestOptions.query", {});
        Object.keys(queryWithArgs).forEach(function (query) {
            queryWithArgs[query] = Mustache.render(queryWithArgs[query], _this.templateArgs);
        });
        return queryWithArgs;
    };
    return HttpServiceRenderer;
}(service_renderer_1.default));
exports.default = HttpServiceRenderer;
//# sourceMappingURL=http_service_renderer.js.map