"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug")("postgres_request_helper");
var _ = require("lodash/fp");
var pg_1 = require("pg");
var db_pool_1 = require("./db_pool");
var postgres_service_renderer_1 = require("./postgres_service_renderer");
var request_helper_1 = require("./request_helper");
var PostgresRequestHelper = /** @class */ (function (_super) {
    __extends(PostgresRequestHelper, _super);
    function PostgresRequestHelper(serviceData) {
        var _this = _super.call(this) || this;
        _this.serviceData = _.cloneDeep(serviceData);
        return _this;
    }
    PostgresRequestHelper.prototype.run = function (args) {
        this.renderer = new postgres_service_renderer_1.default(this.serviceData, args);
        var rendered = this.renderer.render();
        var poolOpts = {
            user: rendered.user,
            password: rendered.pass,
            host: rendered.host,
            port: rendered.port,
            database: rendered.database
        };
        debug(rendered);
        var poolKey = JSON.stringify(poolOpts);
        if (!db_pool_1.default.hasOwnProperty(poolKey)) {
            debug("Pool does not exist for key");
            var opts = __assign({}, poolOpts, { ssl: true });
            db_pool_1.default[poolKey] = new pg_1.Pool(opts);
        }
        var pool = db_pool_1.default[poolKey];
        return pool
            .connect()
            .then(function (client) { return client.query(rendered.query); })
            .then(function (res) { return res.rows; });
        // .finally((client) => client.release());
    };
    return PostgresRequestHelper;
}(request_helper_1.RequestHelper));
exports.default = PostgresRequestHelper;
//# sourceMappingURL=postgres_request_helper.js.map