"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var Mustache = require("mustache");
var service_renderer_1 = require("./service_renderer");
var PostgresServiceRenderer = /** @class */ (function (_super) {
    __extends(PostgresServiceRenderer, _super);
    function PostgresServiceRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PostgresServiceRenderer.prototype.render = function () {
        this.mergeArgsAndEnv();
        return {
            user: this.renderUser(),
            pass: this.renderPass(),
            host: this.renderHost(),
            port: this.renderPort(),
            database: this.renderDatabase(),
            query: this.renderQuery()
        };
    };
    PostgresServiceRenderer.prototype.renderUser = function () {
        var rawUser = _.get(this.serviceData, "requestOptions.user", "");
        return Mustache.render(rawUser, this.templateArgs);
    };
    PostgresServiceRenderer.prototype.renderPass = function () {
        var rawPass = _.get(this.serviceData, "requestOptions.pass", "");
        return Mustache.render(rawPass, this.templateArgs);
    };
    PostgresServiceRenderer.prototype.renderHost = function () {
        var rawHost = _.get(this.serviceData, "requestOptions.host", "");
        return Mustache.render(rawHost, this.templateArgs);
    };
    PostgresServiceRenderer.prototype.renderPort = function () {
        var rawPort = _.get(this.serviceData, "requestOptions.port", "");
        return Mustache.render(rawPort, this.templateArgs);
    };
    PostgresServiceRenderer.prototype.renderDatabase = function () {
        var rawDatabase = _.get(this.serviceData, "requestOptions.database", "");
        return Mustache.render(rawDatabase, this.templateArgs);
    };
    PostgresServiceRenderer.prototype.renderQuery = function () {
        var queryWithArgs = _.get(this.serviceData, "requestOptions.query", []).join("\n");
        queryWithArgs = Mustache.render(queryWithArgs, this.templateArgs);
        return queryWithArgs;
    };
    return PostgresServiceRenderer;
}(service_renderer_1.default));
exports.default = PostgresServiceRenderer;
//# sourceMappingURL=postgres_service_renderer.js.map