import HttpServiceRenderer from "../http_service_renderer";

describe("HTTP Service Renderer", () => {
  it("renders HTTP request details", () => {
    process.env.SERVICE_BASE_URL = "http://some.service.url";
    process.env.SERVICE_PORT = "1234";
    process.env.SERVICE_API_KEY = "abcd";

    const serviceData = {
      id: "SOME_SERVICE/someEndpoint",
      description: "Nice API",
      name: "Some service",
      type: "HTTP",
      requestOptions: {
        host: "{{{host}}}",
        port: "{{port}}",
        path: "/some/endpoint",
        query: {
          key: "{{key}}",
          param1: "{{param1}}",
          param2: "{{param2}}"
        }
      },
      fromEnv: {
        host: "SERVICE_BASE_URL",
        port: "SERVICE_PORT",
        key: "SERVICE_API_KEY"
      },
      service: "SOME_SERVICE"
    };

    const args = {
      param1: "hello",
      param2: "world"
    };

    const expected = {
      json: false,
      baseUrl: "http://some.service.url",
      port: "1234",
      path: "/some/endpoint",
      query: {
        key: "abcd",
        param1: "hello",
        param2: "world"
      }
    };
    const renderer = new HttpServiceRenderer(serviceData, args);
    const rendered = renderer.render();
    expect(rendered).toEqual(expected);
  });
});
