const debug = require("debug")("http_request_helper");
import * as _ from "lodash";
import * as rp from "request-promise";

// import logger from "./logger";
import HttpServiceRenderer from "./http_service_renderer";
import { RequestHelper } from "./request_helper";

export default class HttpRequestHelper extends RequestHelper {
  private serviceData: any;
  private renderer: HttpServiceRenderer;

  constructor(serviceData) {
    super();
    this.serviceData = _.cloneDeep(serviceData);
  }

  public run(args) {
    this.renderer = new HttpServiceRenderer(this.serviceData, args);
    const rendered = this.renderer.render();
    debug("# rendered start");
    debug(rendered);
    debug("# rendered end");
    const options = {
      json: rendered.json,
      qs: rendered.query,
      uri: `${rendered.baseUrl}:${rendered.port}${rendered.path}`
    };

    debug(options);
    return new Promise((resolve, reject) => {
      rp(options)
        .then(result => {
          resolve(result);
        })
        .catch(err => {
          // logger.error(err);
          // logger.error(err.body);
          throw err;
        });
    });
  }
}
