import * as nock from "nock";
import HttpServiceRenderer from "./http_service_renderer";

class HttpRequestMock {
  public mock(serviceData, data) {
    const { type, method, testParams } = serviceData;
    const args = {};
    const renderer = new HttpServiceRenderer(serviceData, args);
    const rendered = renderer.render();

    const scope = nock(`${rendered.baseUrl}:${rendered.port}`).intercept(
      new RegExp(testParams.path),
      method || "GET"
    );

    scope.replyWithFile(200, `fixtures/${data}`);
  }
}

export default HttpRequestMock;
