import * as _ from "lodash";

export default abstract class ServiceRenderer {
  protected readonly serviceData: any;
  protected readonly args: any;
  protected templateArgs: any;

  constructor(serviceData, args) {
    this.serviceData = serviceData;
    this.args = args;
    this.setEnvVars();
  }

  public abstract render(): object;

  protected mergeArgsAndEnv() {
    const fromEnv = _.get(this.serviceData, "fromEnv", {});

    this.templateArgs = {
      ...this.args,
      ...fromEnv
    };
  }

  private setEnvVars() {
    const fromEnv = _.get(this.serviceData, "fromEnv", {});
    Object.keys(fromEnv).forEach(name => {
      fromEnv[name] = process.env[fromEnv[name]];
    });
  }
}
